<!--
 - Created by MarosGrajcar on 11/25/2019.
 -->

<!-- Eqt Add Create Read Update -->
<template>

    <template if:true={loading}>
        <lightning-spinner class="slds-is-relative slds-align--absolute-center slds-p-around--small"
                           alternative-text="Loading" size="medium"></lightning-spinner>
    </template>

    <template if:false={loading}>

        <template if:true={isNewForm}>

            <!--INFORMATION HEADER-->
            <c-eqt_add_header-information floc-info={flockInformation}
                                          expiration-date={expirationDate}></c-eqt_add_header-information>


            <!--MISSING DATA-->
            <c-eqt_add_missing-section add-form={addForm}></c-eqt_add_missing-section>


            <!-- FILES -->
            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-grid slds-wrap slds-p-around--small slds-show_medium">
                <div class="slds-size--6-of-12 slds-border--top slds-p-top-x-small slds-p-horizontal--small">
                    <div class="slds-p-top--small">
                        <lightning-input type="file"
                                         label="Serial Plate of Asset"
                                         required
                                         onchange={handleSerialPlateUpload}>
                        </lightning-input>
                        <template if:true={serialPlateFileName}>
                            <p>{serialPlateFileName}</p>
                        </template>
                    </div>
                </div>

                <div class="slds-size--6-of-12 slds-border--top slds-p-top-x-small slds-p-horizontal--small">
                    <div class="slds-p-top--small">
                        <lightning-input type="file"
                                         label="Attachment"
                                         onchange={handleAttachmentUpload}>
                        </lightning-input>
                        <template if:true={attachmentFileName}>
                            <p>{attachmentFileName}</p>
                        </template>
                    </div>
                </div>

            </div>

            <!--SMALL DEVICES-->
            <div class="slds-hide_medium">
                <div class="slds-p-top--small">
                    <lightning-input type="file"
                                     label="Serial Plate of Asset"
                                     required
                                     onchange={handleSerialPlateUpload}>
                    </lightning-input>
                    <template if:true={serialPlateFileName}>
                        <p>{serialPlateFileName}</p>
                    </template>
                </div>

                <div class="slds-p-top--small">
                    <lightning-input type="file"
                                     label="Attachment"
                                     onchange={handleAttachmentUpload}>
                    </lightning-input>
                    <template if:true={attachmentFileName}>
                        <p>{attachmentFileName}</p>
                    </template>
                </div>

            </div>

            <!--COMMENTS-->
            <c-eqt_comments-section is-user-admin={isUserAdmin} is-new-form={isNewForm}></c-eqt_comments-section>

        </template>

        <template if:false={isNewForm}>
            <!--ICON AND BUTTONS SECTION-->
            <!--MEDIUM AND LARGE DEVICES-->
            <div class="slds-grid slds-wrap slds-card slds-p-around--small slds-m-bottom--small slds-show_medium">
                <span class="slds-size--6-of-12">
                    <lightning-icon icon-name="custom:custom19"></lightning-icon>
                    <span class="slds-text-title_caps slds-p-left--x-small">
                        <b>Add Equipment Form</b> {addForm.Name}
                    </span>
                </span>


                <template if:true={isView}>
                    <span if:false={formClosed} class="slds-size--6-of-12 slds-text-align--right slds-p-left--x-small">
                        <lightning-button label="Edit"
                                          variant="brand"
                                          onclick={editView}>
                        </lightning-button>

                        <lightning-button if:true={isUserAdmin}
                                          class="slds-p-right--x-small slds-p-left--x-small"
                                          label="Processed"
                                          variant="success"
                                          onclick={formProcessed}>
                        </lightning-button>

                        <lightning-button if:true={isUserAdmin}
                                          label="Reject"
                                          variant="destructive"
                                          onclick={formRejectModal}>
                        </lightning-button>
                    </span>
                </template>
            </div>

            <!--SMALL DEVICES-->
            <div class="slds-hide_medium slds-card slds-p-around--small">
                <lightning-icon class="slds-float--left" icon-name="custom:custom19"></lightning-icon>
                <lightning-button if:true={isView}
                                  class="slds-float--right"
                                  label="Edit"
                                  variant="brand"
                                  onclick={editView}>
                </lightning-button>
                <div class="slds-text-title_caps">
                    <b>Add Equipment Form</b>
                    <p>{addForm.Name}</p>
                </div>
            </div>

            <div style="background-color:white">

                <!--INFORMATION HEADER-->
                <c-eqt_add_header-information add-form={addForm}></c-eqt_add_header-information>

                <template if:true={isView}>

                    <!-- MISSING DATA -->
                    <c-eqt_add_missing-section add-form={addForm}
                                               form-id={recordId}
                                               is-view={isView}>
                    </c-eqt_add_missing-section>


                    <!--FILES-->
                    <!--MEDIUM AND LARGE DEVICES-->
                    <div class="slds-grid slds-wrap slds-p-around--small slds-show_medium">

                        <div class="slds-border--top slds-size--6-of-12 slds-p-horizontal--small">
                            <template if:true={containsSerialPlate}>
                                <div class="slds-p-top--small">
                                    Serial Plate
                                    <p if:true={uploadedSerialPlateFile}><a onclick={openFilePreview}
                                                                            data-id={uploadedSerialPlateFile.ContentDocumentId}>{uploadedSerialPlateFile.ContentDocument.Title}</a>

                                    </p>
                                    <p if:true={uploadedSerialPlateAttachment}><a onclick={redirectToRecordPage}
                                                                                  data-id={uploadedSerialPlateAttachment.Id}
                                                                                  data-apiname="Attachment">{uploadedSerialPlateAttachment.Name}</a>
                                    </p>
                                </div>
                            </template>
                        </div>

                        <div class="slds-border--top slds-size--6-of-12 slds-p-horizontal--small">
                            <template if:true={containsAttachment}>
                                <div class="slds-p-top--small">
                                    Attachment
                                    <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                                           data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>
                                    </p>

                                    <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                                       data-id={uploadedAttachment.Id}
                                                                       data-apiname="Attachment">{uploadedAttachment.Name}</a>
                                    </p>
                                </div>
                            </template>
                        </div>
                    </div>

                    <!--SMALL DEVICES-->
                    <div class="slds-hide_medium slds-border--top slds-p-around--small">
                        <template if:true={containsSerialPlate}>
                            <div class="slds-p-top--small">
                                Serial Plate
                                <p if:true={uploadedSerialPlateFile}><a onclick={openFilePreview}
                                                                        data-id={uploadedSerialPlateFile.ContentDocumentId}>{uploadedSerialPlateFile.ContentDocument.Title}</a>

                                </p>
                                <p if:true={uploadedSerialPlateAttachment}><a onclick={redirectToRecordPage}
                                                                              data-id={uploadedSerialPlateAttachment.Id}
                                                                              data-apiname="Attachment">{uploadedSerialPlateAttachment.Name}</a>
                                </p>
                            </div>
                        </template>

                        <template if:true={containsAttachment}>
                            <div class="slds-p-top--small">
                                Attachment
                                <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                                       data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>
                                </p>

                                <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                                   data-id={uploadedAttachment.Id}
                                                                   data-apiname="Attachment">{uploadedAttachment.Name}</a>
                                </p>
                            </div>
                        </template>
                    </div>

                    <!--COMMENTS-->
                    <c-eqt_comments-section form={addForm} is-user-admin={isUserAdmin} is-view={isView}></c-eqt_comments-section>

                    <!-- SYSTEM INFORMATION -->
                    <c-eqt_system-information-section equipment-form={addForm}></c-eqt_system-information-section>


                </template>

                <template if:false={isView}>

                    <!-- MISSING DATA -->
                    <c-eqt_add_missing-section add-form={addForm}
                                               is-view={isView}
                                               original-form={endpointForm}>
                    </c-eqt_add_missing-section>

                    <!-- FILES -->
                    <!--MEDIUM AND LARGE DEVICES-->
                    <div class="slds-grid slds-wrap slds-p-around--small slds-show_medium">
                        <div class="slds-border--top slds-p-top-x-small slds-size--6-of-12 slds-p-horizontal--small">

                            <div class="slds-p-top--small">
                                <template if:true={containsSerialPlate}>
                                    Serial Plate:
                                    <p if:true={uploadedSerialPlateFile}><a onclick={openFilePreview}
                                                                            data-id={uploadedSerialPlateFile.ContentDocumentId}>{uploadedSerialPlateFile.ContentDocument.Title}</a>

                                        <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                               data-id={uploadedSerialPlateFile.ContentDocumentId}
                                                               data-objecttype="file"
                                                               data-fieldtype="serial"
                                                               variant="bare"
                                                               icon-name="utility:close" alternative-text="Remove"
                                                               size="medium"></lightning-button-icon>
                                    </p>
                                    <p if:true={uploadedSerialPlateAttachment}><a onclick={redirectToRecordPage}
                                                                                  data-id={uploadedSerialPlateAttachment.Id}
                                                                                  data-apiname="Attachment">{uploadedSerialPlateAttachment.Name}</a>

                                        <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                               data-id={uploadedSerialPlateAttachment.Id}
                                                               data-objecttype="attachment"
                                                               data-fieldtype="serial"
                                                               variant="bare"
                                                               icon-name="utility:close" alternative-text="Remove"
                                                               size="medium"></lightning-button-icon>
                                    </p>
                                </template>

                                <template if:false={containsSerialPlate}>
                                    <lightning-input type="file"
                                                     label="Serial Plate of Asset"
                                                     required
                                                     onchange={handleSerialPlateUpload}>
                                    </lightning-input>
                                    <template if:true={serialPlateFileName}>
                                        <p>{serialPlateFileName}</p>
                                    </template>
                                </template>


                            </div>
                        </div>

                        <div class="slds-border--top slds-p-top-x-small slds-size--6-of-12 slds-p-horizontal--small">

                            <div class="slds-p-top--small">
                                <template if:true={containsAttachment}>
                                    Attachment:
                                    <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                                           data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>

                                        <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                               data-id={uploadedAttachmentFile.ContentDocumentId}
                                                               data-objecttype="file"
                                                               data-fieldtype="attachment"
                                                               variant="bare"
                                                               icon-name="utility:close" alternative-text="Remove"
                                                               size="medium"></lightning-button-icon>
                                    </p>
                                    <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                                       data-id={uploadedAttachment.Id}
                                                                       data-apiname="Attachment">{uploadedAttachment.Name}</a>

                                        <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                               data-id={uploadedAttachment.Id}
                                                               data-objecttype="attachment"
                                                               data-fieldtype="attachment"
                                                               variant="bare"
                                                               icon-name="utility:close" alternative-text="Remove"
                                                               size="medium"></lightning-button-icon>
                                    </p>
                                </template>

                                <template if:false={containsAttachment}>
                                    <lightning-input type="file"
                                                     label="Attachment"
                                                     onchange={handleAttachmentUpload}>
                                    </lightning-input>
                                    <template if:true={attachmentFileName}>
                                        <p>{attachmentFileName}</p>
                                    </template>
                                </template>
                            </div>

                        </div>

                    </div>

                    <!--SMALL DEVICES-->
                    <div class="slds-hide_medium">

                        <div class="slds-p-top--small">
                            <template if:true={containsSerialPlate}>
                                Serial Plate:
                                <p if:true={uploadedSerialPlateFile}><a onclick={openFilePreview}
                                                                        data-id={uploadedSerialPlateFile.ContentDocumentId}>{uploadedSerialPlateFile.ContentDocument.Title}</a>

                                    <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                           data-id={uploadedSerialPlateFile.ContentDocumentId}
                                                           data-objecttype="file"
                                                           data-fieldtype="serial"
                                                           variant="bare"
                                                           icon-name="utility:close" alternative-text="Remove"
                                                           size="medium"></lightning-button-icon>
                                </p>
                                <p if:true={uploadedSerialPlateAttachment}><a onclick={redirectToRecordPage}
                                                                              data-id={uploadedSerialPlateAttachment.Id}
                                                                              data-apiname="Attachment">{uploadedSerialPlateAttachment.Name}</a>

                                    <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                           data-id={uploadedSerialPlateAttachment.Id}
                                                           data-objecttype="attachment"
                                                           data-fieldtype="serial"
                                                           variant="bare"
                                                           icon-name="utility:close" alternative-text="Remove"
                                                           size="medium"></lightning-button-icon>
                                </p>
                            </template>

                            <template if:false={containsSerialPlate}>
                                <lightning-input type="file"
                                                 label="Serial Plate of Asset"
                                                 required
                                                 onchange={handleSerialPlateUpload}>
                                </lightning-input>
                                <template if:true={serialPlateFileName}>
                                    <p>{serialPlateFileName}</p>
                                </template>
                            </template>


                        </div>


                        <div class="slds-p-top--small">
                            <template if:true={containsAttachment}>
                                Attachment:
                                <p if:true={uploadedAttachmentFile}><a onclick={openFilePreview}
                                                                       data-id={uploadedAttachmentFile.ContentDocumentId}>{uploadedAttachmentFile.ContentDocument.Title}</a>

                                    <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                           data-id={uploadedAttachmentFile.ContentDocumentId}
                                                           data-objecttype="file"
                                                           data-fieldtype="attachment"
                                                           variant="bare"
                                                           icon-name="utility:close" alternative-text="Remove"
                                                           size="medium"></lightning-button-icon>
                                </p>
                                <p if:true={uploadedAttachment}><a onclick={redirectToRecordPage}
                                                                   data-id={uploadedAttachment.Id}
                                                                   data-apiname="Attachment">{uploadedAttachment.Name}</a>

                                    <lightning-button-icon class="slds-p-left--medium" onclick={removeFile}
                                                           data-id={uploadedAttachment.Id}
                                                           data-objecttype="attachment"
                                                           data-fieldtype="attachment"
                                                           variant="bare"
                                                           icon-name="utility:close" alternative-text="Remove"
                                                           size="medium"></lightning-button-icon>
                                </p>
                            </template>

                            <template if:false={containsAttachment}>
                                <lightning-input type="file"
                                                 label="Attachment"
                                                 onchange={handleAttachmentUpload}>
                                </lightning-input>
                                <template if:true={attachmentFileName}>
                                    <p>{attachmentFileName}</p>
                                </template>
                            </template>
                        </div>

                    </div>


                 <c-eqt_comments-section form={addForm} is-user-admin={isUserAdmin} is-view={isView} original-comments={addForm}></c-eqt_comments-section>

                    <!--ACTION BUTTONS-->
                    <!--MEDIUM AND LARGE DEVICES-->
                    <div if:false={editModal} class="slds-p-around--medium slds-card slds-align--absolute-center slds-show_medium">
                        <lightning-button label="Save" variant="brand" onclick={getUserInputs}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={cancelEditView}></lightning-button>
                    </div>

                    <!--SMALL DEVICES-->
                    <div if:false={editModal} class="slds-p-around--medium slds-border--top slds-align--absolute-center slds-hide_medium">
                        <lightning-button label="Save" variant="brand" onclick={getUserInputs}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={cancelEditView}></lightning-button>
                    </div>

                </template>
            </div>

        </template>
    </template>

    <!--FORM REJECT MODAL-->
    <template if:true={openModal}>

        <section class="slds-modal slds-fade-in-open">
            <div class="slds-modal__container custom-modal_wide">
                <header class="slds-modal__header">
                    <button class="slds-button slds-button_icon slds-modal__close" title="Close"
                            onclick={formRejectModal}>
                        <lightning-icon icon-name="utility:close" size="medium">
                        </lightning-icon>
                        <span class="slds-assistive-text">Close</span>
                    </button>
                    <h2 class="slds-text-heading_medium slds-hyphenate">Add Equipment Form Rejection</h2>
                    <template if:true={loading}>
                        <lightning-spinner class="slds-is-relative slds-align--absolute-center slds-p-around--small"
                                           alternative-text="Loading" size="medium"></lightning-spinner>
                    </template>
                </header>
                <template if:false={loading}>
                    <div class="slds-modal__content slds-p-around_medium">
                        <lightning-textarea label="Reason for Rejection" value={reason}
                                            onchange={handleReason}></lightning-textarea>
                    </div>
                    <footer class="slds-modal__footer slds-text-align--left">
                        <lightning-button label="Submit" variant="brand" onclick={rejectForm}></lightning-button>
                        <lightning-button label="Cancel" variant="neutral"
                                          onclick={formRejectModal}></lightning-button>
                    </footer>
                </template>
            </div>
        </section>
        <div class="slds-backdrop slds-backdrop_open"></div>
    </template>

</template>